﻿Type.registerNamespace("Telerik.Web.UI.Helpers");
Type.registerNamespace("Telerik.Web.UI.Widgets");
(function(b,a){var d=function(l){(function(){var n={};
a.extend(l,{trigger:function(q){var r=n[q];
if(!r){return;
}for(var s=0;
s<r.length;
s++){var p=Array.prototype.slice.call(arguments);
p.shift();
p.unshift(this);
r[s].handler.apply(r[s].context,p);
}},_bind:function(q,p){a.each(q,function(r,s){m(r,s,p);
});
},_unbind:function(q,p){a.each(q,function(r,s){o(r,s,p);
});
},_disposeEvents:function(){n=null;
}});
function m(q,r,p){var s=n[q]||[];
s.push({handler:r,context:p});
n[q]=s;
}function o(q,r,p){var s=n[q];
if(!s){return;
}var u=-1;
for(var t=0;
t<s.length;
t++){if(s[t].func==r&&s[t].context==p){u=t;
break;
}}if(u>-1){s=s.splice(u,1);
}n[q]=s;
}})();
};
var h=".Telerik.Web.UI.Draggable",e="mousedown"+h,g="mouseup"+h,f="mousemove"+h,k=$telerik.getMobileEventCounterpart("mousedown")+h,i=$telerik.getMobileEventCounterpart("mouseup")+h,j=$telerik.getMobileEventCounterpart("mousemove")+h,c="dragstart"+h;
b.Widgets.Draggable=function(l,m){this._element=l;
this._options=a.extend({useTransformations:false,shouldPreventDefault:true,enableFrameOverlay:false,enableDelay:false,validateNestedElementsAsTriggers:false,mouseButtonTrigger:b.Widgets.MouseButton.Left,touchHoldDelay:m&&m.touchHoldDelay?Math.min(1000,m.touchHoldDelay):1000,touchHoldDelta:m&&m.touchHoldDelta?Math.min(20,m.touchHoldDelta):20,customScrollingEvaluator:null,useExternalHandle:m&&m.handle,cursorType:"move",handle:l,constraints:{minX:null,minY:null,maxX:null,maxY:null}},m||{});
this._ieTouchActionManager=new b.Helpers.IETouchActionManager(this._options.handle);
this._isScrolling=false;
d(this);
this.initialize();
};
b.Widgets.Draggable.prototype={initialize:function(l,m){this._initStyleVars(true);
this._checkTransformationAvailability();
this._ieTouchActionManager.allowUserTouch();
this._toggleHandleCursor();
this._attachHandlers(true);
this._enabled=true;
},dispose:function(){this._ieTouchActionManager.dispose();
this._attachHandlers(false);
this._initStyleVars(false);
this._disposeEvents();
this._toggleHandleCursor();
this._options=null;
this._element=null;
},get_handle:function(){return this._options.handle;
},set_handle:function(l){this._options.handle=l;
},get_useExternalHandle:function(){return this._options.useExternalHandle;
},get_position:function(){var l=a(this._element).offset();
return{x:l.left,y:l.top};
},get_handlePosition:function(){var l=a(this._options.handle);
return{x:l.offset().left,y:l.offset().top};
},get_useTransform:function(){return this._options.useTransformations;
},set_useTransform:function(l){if(l){this._checkTransformationAvailability();
if(l&&!this._options.useTransformations){alert("The browser does not support CSS3 transformations");
}}else{this._options.useTransformations=false;
}},get_constraints:function(){return this._options.constraints;
},set_constraints:function(l){if(l){if((l.minX&&l.maxX&&l.minX>l.maxX)||(l.minY&&l.maxY&&l.minY>l.maxY)){throw Error("Invalid Parameters");
}}a.extend(this._options.constraints,l||{maxX:null,minX:null,maxY:null,minY:null});
},get_minX:function(){this._options.constraints.minX;
},set_minX:function(m){var l=this._options.constraints;
if((isNaN(m)&&m!==null&&m!=="")||(l.maxX&&m!==null&&l.maxX<m)){throw Error("Invalid Parameters");
}l.minX=m;
},get_maxX:function(){this._options.constraints.maxX;
},set_maxX:function(m){var l=this._options.constraints;
if((isNaN(m)&&m!==null&&m!=="")||(l.minX&&m!==null&&l.minX>m)){throw Error("Invalid Parameters");
}l.maxX=m;
},get_minY:function(){this._options.constraints.minY;
},set_minY:function(m){var l=this._options.constraints;
if((isNaN(m)&&m!==null&&m!=="")||(l.maxY&&m!==null&&l.maxY<m)){throw Error("Invalid Parameters");
}l.minY=m;
},get_maxY:function(){this._options.constraints.maxY;
},set_maxY:function(m){var l=this._options.constraints;
if((isNaN(m)&&m!==null&&m!=="")||(l.minY&&m!==null&&l.minY>m)){throw Error("Invalid Parameters");
}l.maxY=m;
},get_enabled:function(){return this._enabled;
},set_enabled:function(l){this._enabled=l;
},moveTo:function(l){this._moveWithDelta(l);
},add_dragStarting:function(l){this._bind({dragStarting:l});
},remove_dragStarting:function(l){this._unbind({dragStarting:l});
},add_dragStart:function(l){this._bind({dragStart:l});
},remove_dragStart:function(l){this._unbind({dragStart:l});
},add_dragging:function(l){this._bind({dragging:l});
},remove_dragging:function(l){this._unbind({dragging:l});
},add_dragEnd:function(l){this._bind({dragEnd:l});
},remove_dragEnd:function(l){this._unbind({dragEnd:l});
},_initStyleVars:function(l){this._elStyle=l?this._element.style:null;
this._transfPropName=l?this._getBrowserPrefix(true)+"Transform":null;
this._transfStyleProp=l?this._getBrowserPrefix(false)+"transform":null;
},_checkTransformationAvailability:function(){var l=document.body.style;
this._options.useTransformations=(l.transform!==undefined||l[this._transfPropName]!==undefined);
},_getBrowserPrefix:function(m){var l="";
if($telerik.isOpera){l="O";
}else{if($telerik.isSafari){l="webkit";
}else{if($telerik.isIE){l="ms";
}else{if($telerik.isFirefox){l="Moz";
}}}}if(!m){l="-"+l.toLowerCase()+"-";
}return l;
},_getBounds:function(){return $telerik.getBounds(this._element);
},_attachHandlers:function(m){var l=a(this._options.handle);
if(m){this._mouseDownHandlerProxy=a.proxy(this._mouseDownHandler,this);
l.on(e,this._mouseDownHandlerProxy);
l.on(k,this._mouseDownHandlerProxy);
l.on(c,this._dragStartHandle);
}else{l.off(e,this._mouseDownHandlerProxy);
l.off(k,this._mouseDownHandlerProxy);
l.off(c,this._dragStartHandle);
}},_dragStartHandle:function(l){$telerik.cancelRawEvent(l.originalEvent);
},_mouseDownHandler:function(m){if(!this._enabled){return;
}if(this._options.shouldPreventDefault){m.preventDefault();
}if(this._isTouchEvent(m)){a(this._options.handle).off(e,this._mouseDownHandlerProxy);
}if((!this._isTouchEvent(m)&&!this._validateButtonTrigger(m))||(this._options.validateNestedElementsAsTriggers&&!this._validateTargetElemCursor(m))){return;
}var n=this._getEventLocation(m);
this.startCoords=this.deltaHelper={x:n.x,y:n.y};
this.startPosition=this.initialPosition=this.get_position();
var l=new b.Widgets.DraggableEventArgs(this.initialPosition,null,m);
this.trigger("dragStarting",l);
if(!l._cancel){this._mouseMoveHandlerProxy=a.proxy(this._mouseMoveHandler,this);
a(document).on(f,this._mouseMoveHandlerProxy);
a(document).one(this._isTouchEvent(m)?i:g,a.proxy(this._mouseUpHandler,this));
if(this._isTouchEvent(m)&&this._options.enableDelay){this._touchHoldSimulator(m);
}else{this._triggerDragStart(m,this);
}if(this._options.enableFrameOverlay){this._showOverlay();
}}this._cancelDragSelection(m);
},_validateTargetElemCursor:function(l){return $telerik.getComputedStyle(l.target||l.srcElement,"cursor")==this._options.cursorType;
},_validateButtonTrigger:function(l){return((this._options.mouseButtonTrigger&this._eventButtonToMouseButton(l.button))!=0);
},_cancelDragSelection:function(l){if(!this._isTouchEvent(l)){$telerik.cancelRawEvent(l);
}},_touchHoldSimulator:function(l){this._touchMoveHandlerProxy=a.proxy(this._touchMoveHandler,this);
a(document).on(j,this._touchMoveHandlerProxy);
var m=this;
this.touchHoldTimeout=window.setTimeout(function(){if(!m._isScrolling){m._triggerDragStart(l);
}},this._options.touchHoldDelay);
},_touchMoveHandler:function(m){var n=this._getEventLocation(m);
var l={x:this.startCoords.x-n.x,y:this.startCoords.y-n.y};
if(this._options.customScrollingEvaluator){this._isScrolling=this._options.customScrollingEvaluator(this,m);
}else{this._isScrolling=Math.abs(l.x)>this._options.touchHoldDelta||Math.abs(l.y)>this._options.touchHoldDelta;
}},_triggerDragStart:function(m){this._clearTouchHoldTimeout();
var l=new b.Widgets.DraggableEventArgs(this.initialPosition,null,m.originalEvent);
this.trigger("dragStart",l);
if(!l._cancel){if(this._isTouchEvent(m)){a(document).off(j,this._touchMoveHandlerProxy);
}this._mouseMoveHandlerProxy=a.proxy(this._mouseMoveHandler,this);
a(document).on(this._isTouchEvent(m)?j:f,this._mouseMoveHandlerProxy);
}},_clearTouchHoldTimeout:function(){window.clearTimeout(this.touchHoldTimeout);
},_mouseUpHandler:function(m){this._isScrolling=false;
this._clearTouchHoldTimeout();
if(this._options.useTransformations){this._applyTransformation();
}a(document).off(f,this._mouseMoveHandlerProxy);
a(document).off(j,this._mouseMoveHandlerProxy);
a(document).off(this._isTouchEvent(m)?j:f,this._touchMoveHandler);
if(this._isTouchEvent(m)){this.eventTimer=window.setTimeout(a.proxy(this._reatachMouseDownHandlers,this),500);
}var l=new b.Widgets.DraggableEventArgs(this.startPosition,{x:this.get_position().x-this.startPosition.x,y:this.get_position().y-this.startPosition.y},m.originalEvent);
this.trigger("dragEnd",l);
if(this._options.enableFrameOverlay){this._hideOverlay();
}},_reatachMouseDownHandlers:function(){var l=a(this._options.handle);
l.off(e,this._mouseDownHandlerProxy);
l.on(e,this._mouseDownHandlerProxy);
},_mouseMoveHandler:function(l){this._drag(l);
this._cancelDragSelection(l);
},_drag:function(o){var p=this._getEventLocation(o),m=this._options.constraints,n=this._calcConstraints({x:p.x-this.startCoords.x,y:p.y-this.startCoords.y},this.startPosition,m),l=new b.Widgets.DraggableEventArgs(this.startPosition,n,o.originalEvent);
if(!this._options.useTransformations){this.initialPosition=this.get_position();
this.deltaHelper={x:p.x-this.deltaHelper.x,y:p.y-this.deltaHelper.y};
this.deltaHelper=this._calcConstraintsClassic(this.deltaHelper,this.initialPosition,p,this._options.constraints);
}else{this.deltaHelper=n;
}this.trigger("dragging",l);
if(l._cancel==true){return;
}if(this._options.useTransformations){this._dragTransform(this.deltaHelper);
}else{this._dragClassic(this.deltaHelper);
}this.deltaHelper={x:p.x,y:p.y};
},_dragTransform:function(l){this._clearDragTranslation();
this._elStyle[this._transfPropName]+=" translate("+l.x+"px, "+l.y+"px)";
a(this._element).addClass("rdwTransformed");
},_dragClassic:function(l){this._moveWithDelta(l);
},_applyTransformation:function(){var o=this._elStyle[this._transfPropName];
var p="translate(";
strOffset=p.length;
var n=o.substr(o.lastIndexOf(p));
translateValues=n.substr(strOffset,n.indexOf(")")-strOffset);
var m=translateValues.split(",");
var l={x:parseFloat(m[0]),y:parseFloat(m[1])};
this._clearDragTranslation();
this._moveWithDelta(l);
},_clearDragTranslation:function(){if(!a(this._element).hasClass("rdwTransformed")){return;
}var l=this._elStyle[this._transfPropName];
this._elStyle[this._transfPropName]=l.substr(0,l.lastIndexOf("translate("));
a(this._element).removeClass("rdwTransformed");
},_getEventLocation:function(l){if(this._isTouchEvent(l)){return this._getTouchEventLocation(l);
}else{return{x:l.clientX,y:l.clientY};
}},_moveWithDelta:function(l){a(this._element).css({top:parseFloat(a(this._element).css("top"))+parseFloat(l.y)+"px",left:parseFloat(a(this._element).css("left"))+parseFloat(l.x)+"px"});
},_calcConstraints:function(m,n,l){var o=m;
if((l.maxX!=null&&n.x+a(this._element).width()>l.maxX)||(l.minX!=null&&n.x<l.minX)||(l.maxY!=null&&n.y+a(this._element).height()>l.maxY)||(l.minY!=null&&n.y<l.minY)){return{x:0,y:0};
}if(m.x<0){o.x=l.minX!==null&&!isNaN(l.minX)?Math.max(m.x,l.minX-n.x):m.x;
}else{o.x=l.maxX!==null&&!isNaN(l.maxX)?Math.min(m.x,l.maxX-n.x-a(this._element).width()):m.x;
}if(m.y<0){o.y=l.minY!==null&&!isNaN(l.minY)?Math.max(m.y,l.minY-n.y):m.y;
}else{o.y=l.maxY!==null&&!isNaN(l.maxY)?Math.min(m.y,l.maxY-n.y-a(this._element).height()):m.y;
}return o;
},_calcConstraintsClassic:function(m,o,n,l){var p=m;
if((l.maxX&&o.x>l.maxX)||(l.minX&&o.x<l.minX)||(l.maxY&&o.y>l.maxY)||(l.minY&&o.y<l.minY)){return{x:0,y:0};
}if(m.x<0){p.x=o.x+m.x<l.minX?l.minX-o.x:l.maxX&&n.x>l.maxX?0:m.x;
}else{p.x=l.maxX&&o.x+a(this._element).width()+m.x>=l.maxX?l.maxX-o.x-a(this._element).width():l.minX&&n.x<l.minX?0:m.x;
}if(m.y<0){p.y=o.y+this.deltaHelper.y<l.minY?l.minY-o.y:l.maxY&&n.y>l.maxY?0:m.y;
}else{p.y=l.maxY&&o.y+a(this._element).height()+m.y>=l.maxY?l.maxY-o.y-a(this._element).height():l.minY&&n.y<l.minY?0:m.y;
}return p;
},_showOverlay:function(){var l=this._getIFrames(document);
for(var m=0;
m<l.length;
m++){this._createOverlay(l[m]);
}},_hideOverlay:function(){a(".rrFrameOverlay").remove();
},_createOverlay:function(l){var m=$telerik.getBounds(l),n=document.createElement("div");
n.className="rrFrameOverlay";
n.style.cssText="position:absolute; top:"+m.y+"px;left:"+m.x+"px;width:"+m.width+"px;height:"+m.height+"px;background-color: white; opacity: 0; filter: alpha(opacity=0)";
document.body.appendChild(n);
},_getIFrames:function(l){return l.getElementsByTagName("iframe");
},_toggleHandleCursor:function(){var l=this.get_handle();
if(this._origCursor===null){l.style.cursor=this._origCursor;
this._origCursor=null;
}else{this._origCursor=l.style.cursor;
l.style.cursor=this._options.cursorType;
}},_isTouchEvent:function(l){return/(touch)|(mspoint)/i.test(l.type);
},_getTouchEventLocation:function(m){var o=arguments[1],p=o?[o+"X"]:"pageX",q=o?[o+"Y"]:"pageY",n={x:m[p],y:m[q]},l=m.changedTouches||(m.originalEvent?m.originalEvent.changedTouches:m.rawEvent?m.rawEvent.changedTouches:false);
if(l&&l.length<2){n.x=l[0][p];
n.y=l[0][q];
}if($telerik.isMobileIE10&&m.originalEvent){n.x=m.originalEvent[p];
n.y=m.originalEvent[q];
}return n;
},_eventButtonToMouseButton:function(l){if($telerik.isIE6||$telerik.isIE7||$telerik.isIE8){switch(l){case 1:return Telerik.Web.UI.Widgets.MouseButton.Left;
break;
case 4:return Telerik.Web.UI.Widgets.MouseButton.Middle;
break;
case 2:return Telerik.Web.UI.Widgets.MouseButton.Right;
break;
default:return Telerik.Web.UI.Widgets.MouseButton.None;
}}else{switch(l){case 0:return Telerik.Web.UI.Widgets.MouseButton.Left;
break;
case 1:return Telerik.Web.UI.Widgets.MouseButton.Middle;
break;
case 2:return Telerik.Web.UI.Widgets.MouseButton.Right;
break;
default:return Telerik.Web.UI.Widgets.MouseButton.None;
}}}};
b.Widgets.DraggableEventArgs=function(n,l,m){this._cancel=false;
this._position=n;
this._delta=l||{x:0,y:0};
this._domEvent=m;
this._newPosition={x:this._position.x+this._delta.x,y:this._position.y+this._delta.y};
};
b.Widgets.DraggableEventArgs.prototype={get_position:function(){return this._position;
},get_newPosition:function(){return this._newPosition;
},get_domEvent:function(){return this._domEvent;
},get_cancel:function(){return this._cancel;
},set_cancel:function(l){this._cancel=(l===true||l==="true");
}};
Telerik.Web.UI.Helpers.IETouchActionManager=function(l){this.element=l;
};
Telerik.Web.UI.Helpers.IETouchActionManager.prototype={allowUserTouch:function(){if(!this.isPointerEnabled()){return;
}var l=this.getStyle();
this.cachedTouchAction=l.msTouchAction;
l.msTouchAction="none";
},restore:function(){if(!this.isPointerEnabled()){return;
}this.getStyle().msTouchAction=this.cachedTouchAction;
},getStyle:function(){return this.element?this.element.style:{};
},isPointerEnabled:function(){try{return window.navigator.msPointerEnabled;
}catch(l){return false;
}},dispose:function(){this.restore();
this.element=null;
}};
a.registerEnum(b.Widgets,"MouseButton",{None:0,Left:1,Middle:2,Right:4});
})(Telerik.Web.UI,$telerik.$);
